%global meadalpha %{nil}
%global meadrel %{nil}
%global version_major 2
%global version_minor 9
%global version_micro 2
%global commitid 5ca99116734b96102467d97f041bc878f6150603
%global serial 20

%{?scl:%scl_package mod_security}
%{!?scl:%global pkg_name %{name}}

%define _jarsign_opts --nocopy
%bcond_without zip

%define reltag GA

Name: %{?scl_prefix}mod_security
Summary: Open Source Web Application Firewall
Version: 2.9.2
Release: %{serial}.%{reltag}%{?dist}
License: ASL 2.0
URL: https://www.modsecurity.org/

# https://www.modsecurity.org/tarball/2.8.0/modsecurity-2.8.0.tar.gz
# mv mod_security-2.8.0.tar.gz mod_security-2.8.0.tar.gz.orig
# mv modsecurity-2.8.0 mod_security-2.8.0
# tar czf mod_security-2.8.0.tgz mod_security-2.8.0
Source0: ModSecurity-%{commitid}.tar.gz
Source1: mod_security.conf
Source2: 10-mod_security.conf
Source3: mod_security.conf.sample

Group: Development/Libraries

BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot

%if "%{?rhel}" == "7"
# 64 bit only natives on RHEL7
ExcludeArch: i386 i686
%endif

%if "%{?rhel}" == "6"
BuildRequires: perl
BuildRequires: zip
%endif

BuildRequires: libtool
BuildRequires: %{?scl_prefix}httpd-devel
BuildRequires: %{?scl_prefix}libcurl-devel
BuildRequires: %{?scl_prefix}libcurl
BuildRequires: %{?scl_prefix}nghttp2
BuildRequires: %{?scl_prefix}nghttp2-devel
BuildRequires: libxml2-devel
BuildRequires: %{?scl_prefix}apr-devel
BuildRequires: %{?scl_prefix}apr-util-devel
BuildRequires: %{?scl_prefix}apr-util-openssl
BuildRequires: %{?scl_prefix}openssl-devel
BuildRequires: pcre-devel
#Mladen asked to add this BR to fix JWS-203
BuildRequires: lua-devel

BuildRequires: chrpath
BuildRequires: openldap-devel, expat-devel

Requires: %{?scl_prefix}httpd
Requires: %{?scl_prefix}apr
Requires: %{?scl_prefix}apr-util
Requires: %{?scl_prefix}libcurl
%description
Open Source Web Application Firewall

%if %with zip
%package src-zip
Summary:     Container for the source distribution of mod_security
Group:       Development

%description src-zip
Container for the source distribution of mod_security.
%endif

%prep
%setup -q -n ModSecurity-%{commitid}

#Create src zip to include any patches
%if %with zip
zip -q -r %{name}-%{version}-src.zip *
%endif

%build
%{?scl:scl enable %scl - << \EOF}
set -e
./autogen.sh
CFLAGS="-fPIC"
./configure --disable-rpath --enable-collection-global-lock --with-apxs=/opt/rh/jbcs-httpd24/root/usr/sbin/apxs --with-apr=/opt/rh/jbcs-httpd24/root/usr/bin/apr-1-config --with-apu=/opt/rh/jbcs-httpd24/root/usr/bin/apu-1-config --with-curl=/opt/rh/jbcs-httpd24/root/usr/bin/curl-config
make LIBS="${LIBS} -lrt -L%{_libdir} -lcrypto -lssl"
%{?scl:EOF}

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_libdir}/httpd/modules/ \
         $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/httpd/modsecurity.d/
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/httpd/modsecurity.d/activated_rules

install -Dp -m0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/10-mod_security.conf
#install -Dp -m0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/httpd/conf.d/mod_security.conf
# JBCS-334, JBCS-161
install -Dp -m0644 %{SOURCE3} %{buildroot}%{_sysconfdir}/httpd/conf.d/mod_security.conf.sample
#sed  -i 's/Include/IncludeOptional/'  %{buildroot}%{_sysconfdir}/httpd/conf.d/mod_security.conf
install -m 700 -d $RPM_BUILD_ROOT%{_localstatedir}/cache/mod_security

cp apache2/.libs/mod_security2.so $RPM_BUILD_ROOT%{_libdir}/httpd/modules/mod_security2.so
cp tools/rules-updater.pl $RPM_BUILD_ROOT%{_bindir}/rules-updater.pl
#JWS-199
rm $RPM_BUILD_ROOT%{_bindir}/rules-updater.pl
cp mlogc/mlogc $RPM_BUILD_ROOT%{_bindir}/mlogc
cp mlogc/mlogc-batch-load.pl $RPM_BUILD_ROOT%{_bindir}/mlogc-batch-load.pl

%if %with zip
mkdir -p $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev
cp %{name}-%{version}-src.zip $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev/
%endif

%{?scl:%{_root_bindir}}%{!?scl:%{_bindir}}/chrpath -d $RPM_BUILD_ROOT%{_libdir}/httpd/modules/mod_security2.so

%ifarch x86_64
%check
make check
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc authors.txt CHANGES LICENSE NOTICE README.TXT
# %config(noreplace) %{_sysconfdir}/httpd/conf.d/mod_snmp.conf.sample
# %config(noreplace) %{_sysconfdir}/httpd/conf.d/snmpd/snmpd.conf.sample
%{_libdir}/httpd/modules/*.so
%{_bindir}/*
%config(noreplace) %{_sysconfdir}/httpd/conf.d/*.conf.sample
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/*.conf
%dir %{_sysconfdir}/httpd/modsecurity.d
%dir %{_sysconfdir}/httpd/modsecurity.d/activated_rules
%attr(770,apache,root) %dir %{_localstatedir}/cache/mod_security

%if %with zip
%files src-zip
%defattr(-,root,root,-)
%{_javadir}/jbossas-fordev/*
%endif

%changelog
* Tue Dec 17 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 2.9.2-20
- JBCS 2.4.37-SP1.ER1

* Sat Nov 16 2019 cpaas-ops <cpaas-ops@redhat.com> - 2.9.2-19
Built by CPaaS

* Fri Nov 15 2019 cpaas-ops <cpaas-ops@redhat.com> - 2.9.2-18
Built by CPaaS

* Fri Nov 15 2019 cpaas-ops <cpaas-ops@redhat.com> - 2.9.2-17
Built by CPaaS

* Fri Oct 11 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 2.9.2-16
-  Rebuilding JBCS httpd 2.4.37-ER5

* Fri Oct 11 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 2.9.2-15
- JBCS httpd 2.4.37-ER5

* Wed Sep 25 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 2.9.2-14
- Building JCBS 2.4.37.ER4

* Fri Sep 20 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 2.9.2-13
- JBCS httpd 2.4.37.ER3

* Tue Aug 06 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 2.9.2-10
- JBCS 2.4.37.ER2

* Wed Jul 24 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 2.9.2-6
- JBCS 2.4.37.ER1

* Fri Jul 19 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 2.9.2-5
- JBCS 2.4.37.ER1

* Fri Jun 28 2019 Petros Marios Prokopiou <pprokopi@redhat.com> - 2.9.2-2
- Enabled testing for x86_64

* Wed Jun 19 2019 Hui Wang <huwang@redhat.com> - 2.9.2-1
- Upgrade to 2.9.2 and build with new httpd 2.4.37

* Thu May 10 2018 Hui Wang <huwang@redhat.com> - 2.9.1-23
- Fix JBCS-161 and JBCS-247

* Tue Apr 24 2018 Hui Wang <huwang@redhat.com> - 2.9.1-22
- Fix JBCS-161

* Tue Mar 06 2018 Jean-Frederic Clere <jclere@redhat.com> - 2.9.1-21
- bump serial number...

* Tue Mar 06 2018 Jean-Frederic Clere <jclere@redhat.com> - 2.9.1-20
- retry

* Tue Mar 06 2018 Hui Wang <huwang@redhat.com> - 2.9.1-20
- Rebuild

* Tue Mar 06 2018 Jean-Frederic Clere <jclere@redhat.com> - 2.9.1-20
- Add our openssl in spec file.

* Tue Mar 06 2018 Hui Wang <huwang@redhat.com> - 2.9.1-20
- Rebuild


* Mon Mar 05 2018 Hui Wang <huwang@redhat.com> - 2.9.1-20
- Rebuild

* Mon Mar 05 2018 Georgios Zaronikas Karagiannis <gzaronik@redhat.com> - 2.9.1-19
- Rebuild

* Tue Apr 18 2017 Georgios Zaronikas Karagiannis <gzaronik@redhat.com> - 2.9.1-19
- Build for JBCS httpd 2.4.23 SP1 DR3

* Fri Dec 02 2016 Georgios Zaronikas Karagiannis <gzaronik@redhat.com> - 2.9.1-18
- Build for CR1

* Wed Oct 26 2016 Hui Wang <huwang@redhat.com> - 2.9.1-17
- Rebuild

* Mon Oct 10 2016 Jean-Frederic Clere <jclere@redhat.com> - 2.9.1-17
- remove JWS3 refrences: Fix JBCS-187

* Mon Oct 03 2016 Georgios Zaronikas Karagiannis <gzaronik@redhat.com> - 2.9.1-16
- Changing lookaside sources to contain patch for JWS-489

* Mon Sep 19 2016 Coty Sutherland <csutherl@redhat.com> - 2.9.1-16
- Resolves: JWS3-56 Ship a template configuration file for mod_security with httpd

* Thu Aug 18 2016 Patrick Sutherland <csutherl@redhat.com> - 2.9.1-15
-

* Mon Jul 25 2016 Patrick Sutherland <csutherl@redhat.com> - 2.9.1-14
-

* Mon Jul 25 2016 Coty Sutherland <csutherl@redhat.com> - 0:2.9.1-2
- Resolves: JBCS-120 update mod_security to 2.9.1

* Tue Jul 19 2016 Jean-Frederic Clere <jclere@redhat.com> - 0:2.9.1-1
- update to latest version.

* Mon Mar 21 2016 David Walluck <dwalluck@redhat.com> - 2.8.0-13
- fix rpath

* Mon Mar 21 2016 Fernando Nasser <fnasser@redhat.com> - 2.8.0-12
- Remove rpath

* Tue Feb 16 2016 Fernando Nasser <fnasser@redhat.com> - 2.8.0-11
- Build from source-repos

* Thu Jan 28 2016 Fernando Nasser <fnasser@redhat.com> - 0:2.8.0-9
- Build in the jbcs-httpd24 collection

* Thu Jan 28 2016 Hui Wang <huwang@redhat.com> - 0:2.8.0-7
- Mladen adviced to add BR lua-devel to fix jws-203

* Mon Dec 21 2015 Fernando Nasser <fnasser@redhat.com> - 0:2.8.0-7
- Build in the jbcs-httpd24 collection

* Tue Aug 18 2015 Weinan Li <weli@redhat.com> - 0:2.8.0-6
- JWS-199 Apache HTTP rules updater is obsolete

* Tue Jan 06 2015 Weinan Li <weli@redhat.com> - 0:2.8.0-5
- Fix jws3 renaming

* Thu Nov 27 2014 Weinan Li <weli@redhat.com> - 0:2.8.0-4
- move mlogc to mlogc-jws3

* Wed Nov 26 2014 Weinan Li <weli@redhat.com> - 0:2.8.0-3
- rename to mod_security-jws3

* Mon Nov 17 2014 Weinan Li <weli@redhat.com> - 0:2.8.0-2
- Rebuild to enable zip across all platforms

* Tue Oct 21 2014 Weinan Li <weli@redhat.com> - 0:2.8.0-1
- Initial import
